include defs32.inc
include apicalls.inc
include message.inc

dialog_name	equ	1
IDC_OK		equ	101

	extrn	LoadLibraryA:proc
	extrn	FreeLibrary:proc
	extrn	GetProcAddress:proc

	.386
	.model flat,stdcall
	.data
lib_name	db	"FBengine.DLL",0
prc_name	db	"RegisterFBClass",0

	.data?

wind_hnd	dd	?; dialog window handle
hInst		dd	?
dll_hInst	dd	?
prc_addr	dd	?

	.code
_start:
	xor	ebx,ebx
	call	GetModuleHandleA,ebx
	mov	hInst,eax

	call	LoadLibraryA,offset lib_name
	mov	dll_hInst,eax
	call	GetProcAddress,dll_hInst,offset prc_name
	mov	prc_addr,eax
	call	dword ptr [prc_addr]
	call	DialogBoxParamA,hInst,1,ebx,offset dialog_proc,ebx

	call	FreeLibrary,dll_hInst
	call	ExitProcess,0

dialog_proc	proc	dp_hWnd:dword, dp_uMsg:dword, dp_wParam:dword, dp_lParam:dword
	mov	ecx,dp_hWnd
	mov	eax,dp_uMsg
	mov	wind_hnd,ecx
	cmp	eax,WM_INITDIALOG
	jne	not_initdialog
	call	GetDlgItem,dp_hWnd,101
	call	EnableWindow,eax,0
	jmp	not_exit

not_initdialog:
	cmp	eax,WM_CLOSE
	jne	not_close
	call	EndDialog,wind_hnd,0
	jmp	not_exit

not_close:
	cmp	eax,WM_COMMAND
	jne	not_command
	cmp	dp_wParam,102
	je	button_pressed
	jmp	not_exit
button_pressed:
	jmp	not_exit
not_exit:
	xor	eax,eax
	inc	eax
	ret
not_command:
	xor	eax,eax
	ret
dialog_proc	endp

end	_start
