include defs32.inc
include apicalls.inc
include message.inc

dialog_name	equ	1
IDC_OK		equ	101

	.386
	.model flat,stdcall
	.data
BtnClsName	db	"BUTTON",0
OurClass	db	"MyBtnClassFlat",0
	.data?

wc	WNDCLASSEX <?,?,?,?,?,?,?,?,?,?,?,?>
wind_hnd	dd	?; dialog window handle
null_pen_hnd	dd	?; pen handle
hInst		dd	?
OldWndProc	dd	?
fucking_p	LPAINT	<>
	.code
_start:
	xor	ebx,ebx
	call	GetModuleHandleA,ebx
	mov	hInst,eax

	mov	wc.cbSize,size WNDCLASSEX
	call	GetClassInfoExA,0,offset BtnClsName,offset wc
	push	wc.lpfnWndProc
	pop	OldWndProc
	mov	wc.lpfnWndProc, OFFSET butn_proc
	push	hInst
	pop	wc.hInstance
	mov	wc.lpszClassName,offset OurClass
	call	RegisterClassExA, offset wc

	call	DialogBoxParamA,hInst,1,ebx,offset dialog_proc,ebx

	cmp	eax,0ffffffffh
	jz	failure

failure:
	call	ExitProcess,ebx

dialog_proc	proc	dp_hWnd:dword, dp_uMsg:dword, dp_wParam:dword, dp_lParam:dword
	mov	ecx,dp_hWnd
	mov	eax,dp_uMsg
	mov	wind_hnd,ecx
	cmp	eax,WM_INITDIALOG
	jne	not_initdialog
	call	CreatePen,PS_NULL,0,0
	mov	null_pen_hnd,eax
	call	GetDlgItem,dp_hWnd,101
	call	EnableWindow,eax,0
	jmp	not_exit

not_initdialog:
	cmp	eax,WM_CLOSE
	jne	not_close
	call	DeleteObject,null_pen_hnd
	call	EndDialog,wind_hnd,0
	jmp	not_exit

not_close:
	cmp	eax,WM_COMMAND
	jne	not_command
	cmp	dp_wParam,102
	je	button_pressed
	jmp	not_exit
button_pressed:
	jmp	not_exit
not_exit:
	xor	eax,eax
	inc	eax
	ret
not_command:
	xor	eax,eax
	ret
dialog_proc	endp

butn_proc	proc hBtnWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
LOCAL	tmouse:TRACKMOUSEEVENT
	mov	eax,uMsg
	cmp	eax,WM_LBUTTONDOWN
	je	left_button_down
	cmp	eax,WM_LBUTTONUP
	je	left_button_up
	cmp	eax,WM_MOUSEMOVE
	je	mouse_move
	cmp	eax,WM_MOUSELEAVE
	je	wm_paint
	cmp	eax,WM_PAINT
	je	wm_paint
end_edit:
	call	CallWindowProcA,OldWndProc,hBtnWnd,uMsg,wParam,lParam
noth2do:
	ret

mouse_move:
	call	draw_3d_button,wParam,hBtnWnd
	mov	tmouse.tcbSize,10h
	mov	tmouse.dwFlags,TME_LEAVE
	mov	eax,hBtnWnd
	mov	tmouse.hwndTrack,eax
	mov	tmouse.dwHoverTime,HOVER_DEFAULT
	lea	eax,offset tmouse
	call	TrackMouseEvent,eax
	jmp	noth2do
left_button_down:
	call	draw_3d_button,1,hBtnWnd
	jmp	noth2do
left_button_up:
	call	draw_3d_button,0,hBtnWnd
	jmp	noth2do
wm_paint:
	call	BeginPaint,hBtnWnd,offset fucking_p
	call	draw_3d_button,-1,hBtnWnd
	call	EndPaint,hBtnWnd,offset fucking_p
	jmp	noth2do
butn_proc	endp

draw_3d_button	proc HowToDraw:dword, hWnd:dword
local	hbmp:dword,hdc:dword,rct:RECT
	push	ebx
	push	esi
	push	edi
	call	IsWindowEnabled,hWnd
	test	eax,eax
	jne	can_press
	mov	dword ptr HowToDraw,-2
can_press:
	call	CreateCompatibleDC,0
	mov	hdc,eax
	lea	eax,dword ptr [rct]
	call	GetWindowRect,hWnd,eax
	call	GetWindowDC,hWnd
	push	eax
	mov	ecx,eax
	mov	eax,rct.right
	sub	eax,rct.left
	mov	rct.right,eax
	mov	rct.left,0
	mov	ebx,rct.bottom
	sub	ebx,rct.top
	mov	rct.bottom,ebx
	mov	rct.top,0
	call	CreateCompatibleBitmap,ecx,eax,ebx
	mov	hbmp,eax
	call	SelectObject,hdc,eax
	pop	eax
	call	ReleaseDC,hWnd,eax
	call	SelectObject,hdc,null_pen_hnd

	cmp	dword ptr HowToDraw,-2
	je	flat_colors
	cmp	dword ptr HowToDraw,-1
	jne	select_3d
flat_colors:
	mov	ebx,COLOR_BTNFACE
	mov	edi,ebx
	jmp	begin_draw_3d
select_3d:
	mov	ebx,COLOR_BTNHIGHLIGHT;COLOR_3DLIGHT
	mov	edi,COLOR_BTNSHADOW
	cmp	dword ptr HowToDraw,0
	je	begin_draw_3d
	xchg	ebx,edi
begin_draw_3d:
	call	GetSysColorBrush,ebx;COLOR_3DLIGHT
	call	SelectObject,hdc,eax
	call	Rectangle,hdc,rct.left,rct.top,rct.right,rct.bottom

	inc	dword ptr [rct.left]
	inc	dword ptr [rct.top]
	call	GetSysColorBrush,edi;COLOR_BTNSHADOW
	call	SelectObject,hdc,eax
	call	Rectangle,hdc,rct.left,rct.top,rct.right,rct.bottom

	dec	dword ptr [rct.right]
	dec	dword ptr [rct.bottom]

	call	GetSysColorBrush,COLOR_BTNFACE
	call	SelectObject,hdc,eax
	call	Rectangle,hdc,rct.left,rct.top,rct.right,rct.bottom
	mov	eax,COLOR_BTNTEXT
	cmp	dword ptr HowToDraw,-2
	jne	not_dis_btn
	mov	eax,COLOR_GRAYTEXT
not_dis_btn:
	call	GetSysColor,eax
	call	SetTextColor,hdc,eax
	push	eax
	call	draw_button_text,hWnd,hdc,rct.left,rct.top,rct.right,rct.bottom
	pop	eax
	call	SetTextColor,hdc,eax
	call	GetWindowDC,hWnd
	mov	ebx,eax
	mov	eax,rct.right
	mov	esi,rct.bottom
	sub	eax,rct.left
	sub	esi,rct.top
;	cmp	dword ptr HowToDraw,-1
;	je	continue_flat
	inc	eax
	inc	esi
continue_flat:
	call	BitBlt,ebx,0,0,eax,esi,hdc,0,0,SRCCOPY
	
	call	ReleaseDC,hWnd,ebx
	call	DeleteObject,hbmp
	call	DeleteDC,hdc
	pop	edi
	pop	esi
	pop	ebx
	ret
draw_3d_button	endp

draw_button_text	proc	hWnd,hdc,_L,_T,_R,_B:dword
local	txt_size:TSIZE
	push	edx
	push	ecx
	push	ebx
	push	esi
	push	edi

	call	GetTextAlign,dword ptr [hdc]
	push	eax
	call	GetStockObject,DEFAULT_GUI_FONT
	push	eax
	call	SelectObject,dword ptr [hdc],eax

	call	SetBkMode,dword ptr [hdc], TRANSPARENT
	push	eax
	call	SelectObject,dword ptr [hdc],eax

	call	SetTextAlign,dword ptr [hdc],TA_CENTER
	call	SendMessageA,dword ptr hWnd,WM_GETTEXTLENGTH,0,0
	inc	eax
	push	eax
	call	GlobalAlloc,GMEM_FIXED+GMEM_ZEROINIT,eax
	mov	edi,eax
	pop	eax
	call	SendMessageA,dword ptr hWnd,WM_GETTEXT,eax,edi
	call	lstrlenA,edi
	push	eax
	lea	esi,dword ptr [txt_size]
	call	GetTextExtentPoint32A,dword ptr [hdc],edi,eax,esi
	mov	edx,dword ptr [_R]
	sub	edx,dword ptr [_L]
	shr	edx,1
	mov	eax,dword ptr [_B]
	sub	eax,dword ptr [_T]
	sub	eax,dword ptr [txt_size+4]
	shr	eax,1
	pop	ecx
	call	TextOutA,dword ptr [hdc],edx,eax,edi,ecx
	pop	eax
	call	SetBkMode,dword ptr [hdc],eax
	pop	eax
	call	SelectObject,dword ptr [hdc],eax
	pop	eax
	call	SetTextAlign,dword ptr [hdc],eax
	call	GlobalFree,edi
	pop	edi
	pop	esi
	pop	ebx
	pop	ecx
	pop	edx
	ret
draw_button_text	endp

draw_flat_button	proc hWnd:dword
local	hdc:dword,brct:RECT
	push	esi
	push	ebx
	call	GetWindowDC,dword ptr [hWnd]
	mov	hdc,eax
	lea	esi,brct
	call	GetWindowRect,dword ptr [hWnd],esi
	call	GetSysColorBrush,COLOR_BTNFACE
	call	SelectObject,dword ptr [hdc],eax
	call	SelectObject,dword ptr [hdc],null_pen_hnd
	call	Rectangle,dword ptr [hdc],rct.left,rct.top,rct.right,rct.bottom
	call	draw_button_text,dword ptr [hWnd]
	call	ReleaseDC,hWnd,hdc
	pop	ebx
	pop	esi
	ret
draw_flat_button	endp

end	_start
