﻿;https://www.purebasic.fr/english/viewtopic.php?t=73723
;26.03.2024 15:40-15:48 draw text 16:11 just borrow text from TASM;:
;27.03.2024 6:32 6:46 done,vertical text align
Global oldProc

Procedure BtnCallback(hWnd, Msg, wParam, lParam)
  Select Msg
      
    Case #WM_NCPAINT
      InvalidateRect_(hWnd, 0, 0)
      ProcedureReturn 0
      
    Case #WM_PAINT
      ;Debug IsWindowEnabled_(hwnd)
      BeginPaint_(hWnd, ps.PAINTSTRUCT)
      Select SendMessage_(hWnd, #BM_GETSTATE, 0, 0)
        Case 0, 8;inactive
          FillRect_(ps\hdc, ps\rcPaint, GetSysColorBrush_(#COLOR_BTNFACE))
        Case 512, 520, 616;active button
          ;        FillRect_(ps\hdc, ps\rcPaint,GetSysColorBrush_(#COLOR_BTNHILIGHT))
          rc.RECT=ps\rcPaint
          FillRect_(ps\hdc, rc, GetSysColorBrush_(#COLOR_BTNHIGHLIGHT))
          rc\left+1
          rc\top+1
          FillRect_(ps\hdc, rc, GetSysColorBrush_(#COLOR_BTNSHADOW))
          rc\right-1
          rc\bottom-1
          FillRect_(ps\hdc, rc, GetSysColorBrush_(#COLOR_BTNFACE))

        Case 620;pressed button
          rc.RECT=ps\rcPaint
          FillRect_(ps\hdc, rc, GetSysColorBrush_(#COLOR_BTNSHADOW))
          rc\left+1
          rc\top+1
          FillRect_(ps\hdc, rc, GetSysColorBrush_(#COLOR_BTNHIGHLIGHT))
          rc\right-1
          rc\bottom-1
          FillRect_(ps\hdc, rc, GetSysColorBrush_(#COLOR_BTNFACE))


      EndSelect  
      ;drawtext
      *m=GetWindowLong_(hwnd,#GWL_USERDATA)
      tl=lstrlen_(*m)
      SelectObject_(ps\hdc,GetStockObject_(#DEFAULT_GUI_FONT))
      SetBkMode_(ps\hdc,#TRANSPARENT)
      SetTextAlign_(ps\hdc,#TA_CENTER)
      ;incorrect position, gettextextentpoint
      If IsWindowEnabled_(hwnd)
        tc=#COLOR_BTNTEXT
      Else
        tc=#COLOR_GRAYTEXT
      EndIf
      ;draw text
      SetTextColor_(ps\hdc,GetSysColor_(tc))
      xc=ps\rcPaint\left+(ps\rcPaint\right-ps\rcPaint\left)/2
      ; vertical
      GetTextExtentPoint32_(ps\hdc,*m,tl,ts.SIZE);SIZE={cx,cy}
      cy=(ps\rcPaint\bottom-ps\rcPaint\top-ts\cy)/2
      TextOut_(ps\hdc,xc,cy,*m,tl)
      EndPaint_(hWnd, ps)
      ProcedureReturn 0 
    Case #WM_NCDESTROY
      SetWindowLongPtr_(hWnd, #GWL_WNDPROC, @oldProc)
      ProcedureReturn 0
  EndSelect
  ProcedureReturn CallWindowProc_(oldProc, hWnd, Msg, wParam, lParam)
EndProcedure

OpenWindow(0, 0, 0, 320, 200, "Flat Button 3d", #PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered|#PB_Window_Invisible)

ButtonGadget(0, 10, 10, 100, 30, "Button")
ButtonGadget(1, 10, 40, 100, 30, "Button2")
SetWindowLong_(GadgetID(0),#GWL_USERDATA,?bt1)
SetWindowLong_(GadgetID(1),#GWL_USERDATA,?bt2)
DisableGadget(1,1)
oldProc = SetWindowLongPtr_(GadgetID(0), #GWL_WNDPROC, @BtnCallback())
SetWindowLongPtr_(GadgetID(1), #GWL_WNDPROC, @BtnCallback())

HideWindow(0, #False)

Repeat
  event = WaitWindowEvent()
  Select event
    Case #PB_Event_Gadget
      Select EventGadget()
          
        Case 0
          ;          Beep_(800,50)
          Debug "button 0"
      EndSelect
  EndSelect
Until event = #PB_Event_CloseWindow

DataSection
  bt1:
  Data.s "Button!"
  bt2:
  Data.s "Button 2"

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 2
; Folding = -
; EnableUnicode
; EnableXP
; Executable = flatb3d.exe